Bug 1410885 - Media (volume) keys on Sun keyboard no longer work
Summary: Media (volume) keys on Sun keyboard no longer work
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: mate-desktop
Version: 25
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Wolfgang Ulbrich
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-06 17:31 UTC by spamempty
Modified: 2017-12-12 10:12 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:12:54 UTC
Type: Bug


Attachments (Terms of Use)

Description spamempty 2017-01-06 17:31:01 UTC
Description of problem:

Upgrading from Fedora 24 to 25 disabled the functionality of the multimedia keys on Sun type 6/7 USB keyboards (PC layout, although probably not relevant). The "Keyboard Shortcuts" (mate-keybinding-properties) tool maps all of these keys to 0xffffff.

HOWEVER, if the sun keyboard compatibility is disabled in mate-keyboard-properties, these keys work properly and the left-panel keys (Stop, Again, Front, Copy, Paste, etc.) stop working, and now _they_ map to 0xffffff.

Version-Release number of selected component (if applicable):
Fedora 25, Mate 1.16, current as of 2017/01/05.

How reproducible:
100%. All the time.

Steps to Reproduce:
1. In mate-keyboard-properties, select a Sun Type 7 USB model (in "Layouts") and under Options, select "Maintain key compatibility with old Solaris keycodes"
2. Volume keys no longer have any effect.
3.

Actual results:
No function from multimedia keys. (or alternatively, no function from left panel keys)

Expected results:
Prior to the upgrade, all of these keys worked as expected.

Additional info:

Comment 1 Pawel Veselov 2017-02-14 20:47:00 UTC
I found that having the compatibility flag turned on is generally a bad idea, and is not meant for USB keyboards. My volume keys work just fine.

However, I do have problems with SunFront button. Haven't checked others.

xev for Front button:

KeyRelease event, serial 38, synthetic NO, window 0x4400001,
    root 0x39c, subw 0x0, time 1195405, (-506,390), root:(3726,613),
    state 0x0, keycode 140 (keysym 0x1005ff71, SunFront), same_screen YES,
    XLookupString gives 0 bytes: 
    XFilterEvent returns: False

The keyboard shortcuts setting screen shows 0xffffff or Mod4+0xffffff when attempting to map the key. The key does no action afterwards. IMHO, the keysym value overflows something.

Comment 2 Wolfgang Ulbrich 2017-02-14 20:57:07 UTC
(In reply to spamempty from comment #0)
> Description of problem:
> 
> Upgrading from Fedora 24 to 25 disabled the functionality of the multimedia
> keys on Sun type 6/7 USB keyboards (PC layout, although probably not
> relevant). The "Keyboard Shortcuts" (mate-keybinding-properties) tool maps
> all of these keys to 0xffffff.
> 
> HOWEVER, if the sun keyboard compatibility is disabled in
> mate-keyboard-properties, these keys work properly and the left-panel keys
> (Stop, Again, Front, Copy, Paste, etc.) stop working, and now _they_ map to
> 0xffffff.
> 
> Version-Release number of selected component (if applicable):
> Fedora 25, Mate 1.16, current as of 2017/01/05.
> 
> How reproducible:
> 100%. All the time.
> 
> Steps to Reproduce:
> 1. In mate-keyboard-properties, select a Sun Type 7 USB model (in "Layouts")
> and under Options, select "Maintain key compatibility with old Solaris
> keycodes"
> 2. Volume keys no longer have any effect.
> 3.
> 
> Actual results:
> No function from multimedia keys. (or alternatively, no function from left
> panel keys)
> 
> Expected results:
> Prior to the upgrade, all of these keys worked as expected.
> 
Which upgrade?
Use 'dnf history' command to be more specific.
> Additional info:

Comment 3 Pawel Veselov 2017-02-14 21:20:35 UTC
For me personally, this worked fine in top of F23 as of today, and stopped working once I updated to F25 (also today).

   147 | update                   | 2017-02-14 12:32 | Update         |    2 EE
   146 | --releasever=25 system-u | 2017-02-14 11:34 | E, I, O, R, U  | 2793 EE
   145 | install dnf-plugin-syste | 2017-02-14 10:05 | Install        |    2   
   144 | install rfkill           | 2017-02-04 14:18 | Install        |    1   
   143 | update                   | 2017-02-04 14:15 | Update         |    2 EE

I.e. this was working until #147.

Comment 4 Wolfgang Ulbrich 2017-02-15 06:02:33 UTC
If it stoped working after #147
dnf history info 147

Comment 5 Pawel Veselov 2017-02-15 19:11:19 UTC
My bad. Not #147, #146. As I said, it was a full system upgrade from (recently updated) F23 to F25. There is like 2.5k packages involved. I've posted it at http://pastebin.com/bqStCRn9

Also, this is what the settings looks like when trying to use the Front key: http://www.picpaste.com/Screenshot_at_2017-02-15_11-09-36-JyZUVgKi.png

Comment 6 Wolfgang Ulbrich 2017-02-16 07:44:41 UTC
Ok, between f23 and f25 MATE was updated from 1.14 to 1.14, but the relevant package libmatekbd has minimal changes, see git log
https://github.com/mate-desktop/libmatekbd/commits/1.16
Well, the layouts are from kbd package which is upgraded in your log.

 Upgraded    kbd-2.0.2-8.fc23.x86_64                                        @updates/23
    Upgrade         2.0.3-3.fc24.x86_64                                         @@commandline

rpm -qa kbd should confirm that.

Honestly, i do not really know what's going wrong here and it's hard to reproduce that without a sun keyboard.
With my usb keyboards i never used a special layout since i use linux.
And i can assign a key to the front key, ie. 'crtl + f'
So maybe kbd maintainer knows more than me about.

Comment 7 Vitezslav Crhonek 2017-02-16 08:52:47 UTC
kbd keymaps are used purely in text console and it has nothing to do with key functionality in graphical mode.

As far as I know, this issue could be connected with xkeyboard-config, xkb* or kernel.

Comment 8 Pawel Veselov 2017-02-16 09:05:07 UTC
IMO, this is Xorg stuff even, not kbd. The keysym value is off the charts, but I don't understand how that particular keysym value is derived (So I don't know which file to check for changes). It's not in keysymdef.h. I can see mappings saying the SunFront is same as I15, whatever that is.

I would try any other key that has a keysym value over 24bit, and see if it shows the same problem with the Mate keyboard mapper. keysymdef.h has a bunch, but I don't know how to generate them from a keyboard. Probably by installing like a Georgian script.


In fact, I was able to reproduce this problem that way.
* Install Georgia/Georgian layout.
* Open the Mate keyboard mapping settings
* Click on any shortcut
* Switch to georgian layout (ka)
* Press "a" (Latin A) key
* Observe the shortcut set to 0xffffff (it should be either Georgian_an, or, if by code, 0x10010d0)

So, not sure if the new category is correct.

Comment 9 Peter Hutterer 2017-09-05 22:18:01 UTC
Based on Pawel's observations in Comment 8, I'm punting this back to mate. Comment 1 also shows that X does the right thing, SunFront shows up in the xev output. This is an issue with mapping the key in mate

Comment 10 Wolfgang Ulbrich 2017-09-05 22:47:57 UTC
I have no idea to fix that....

Comment 11 Pawel Veselov 2017-09-06 09:09:58 UTC
I've traced thit to GDK so far, there is a function that converts key sym to key code. The keysym in this case is 0x10010d0, and the key code it spits back is -1. I'll look more into this when I have time.

Comment 12 Pawel Veselov 2017-09-06 14:49:50 UTC
Also, as I previously stated, having Sun keyboard is not required, I've published the steps on how to reproduce it using a national layout in https://bugzilla.redhat.com/show_bug.cgi?id=1410885#c8.

Comment 13 Wolfgang Ulbrich 2017-09-06 14:54:13 UTC
Patch is welcome....

Comment 14 Fedora End Of Life 2017-11-16 19:48:16 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 15 Fedora End Of Life 2017-12-12 10:12:54 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.